# mzTab-M reference implementation and validation API.
# 
# This is the mzTab-M reference implementation and validation API service.
# 
# OpenAPI spec version: 2.0.0
# Contact: nils.hoffmann@isas.de
# Generated by: https://github.com/swagger-api/swagger-codegen.git


#' SmallMoleculeSummary Class
#'
#' The small molecule summary section is table-based, represented summarized quantitative information across assays and study variables, grouped by identification in rows. The small molecule section MUST always come after the metadata section. All table columns MUST be Tab separated. There MUST NOT be any empty cells; missing values MUST be reported using “null” for columns where Is Nullable &#x3D; “True”.  Each row of the small molecule section is intended to report one final result to be communicated in terms of a molecule that has been quantified. In many cases, this may be the molecule of biological interest, although in some cases, the final result could be a derivatized form as appropriate – although it is desirable for the database identifier(s) to reference to the biological (non-derivatized) form. In general, different adduct forms would generally be reported in the Small Molecule Feature section.  The order of columns MUST follow the order specified below.  All columns are MANDATORY except for “opt_” columns. 
#'
#' @field prefix 
#' @field header_prefix 
#' @field sml_id 
#' @field smf_id_refs 
#' @field database_identifier 
#' @field chemical_formula 
#' @field smiles 
#' @field inchi 
#' @field chemical_name 
#' @field uri 
#' @field theoretical_neutral_mass 
#' @field adduct_ions 
#' @field reliability 
#' @field best_id_confidence_measure 
#' @field best_id_confidence_value 
#' @field abundance_assay 
#' @field abundance_study_variable 
#' @field abundance_variation_study_variable 
#' @field opt 
#' @field comment 
#'
#' 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
SmallMoleculeSummary <- R6::R6Class(
  'SmallMoleculeSummary',
  public = list(
    `prefix` = NULL,
    `header_prefix` = NULL,
    `sml_id` = NULL,
    `smf_id_refs` = NULL,
    `database_identifier` = NULL,
    `chemical_formula` = NULL,
    `smiles` = NULL,
    `inchi` = NULL,
    `chemical_name` = NULL,
    `uri` = NULL,
    `theoretical_neutral_mass` = NULL,
    `adduct_ions` = NULL,
    `reliability` = NULL,
    `best_id_confidence_measure` = NULL,
    `best_id_confidence_value` = NULL,
    `abundance_assay` = NULL,
    `abundance_study_variable` = NULL,
    `abundance_variation_study_variable` = NULL,
    `opt` = NULL,
    `comment` = NULL,
    initialize = function(`prefix`, `header_prefix`, `sml_id`, `smf_id_refs`, `database_identifier`, `chemical_formula`, `smiles`, `inchi`, `chemical_name`, `uri`, `theoretical_neutral_mass`, `adduct_ions`, `reliability`, `best_id_confidence_measure`, `best_id_confidence_value`, `abundance_assay`, `abundance_study_variable`, `abundance_variation_study_variable`, `opt`, `comment`){
      if (!missing(`prefix`)) {
        stopifnot(is.character(`prefix`), length(`prefix`) == 1)
        self$`prefix` <- `prefix`
      }
      if (!missing(`header_prefix`)) {
        stopifnot(is.character(`header_prefix`), length(`header_prefix`) == 1)
        self$`header_prefix` <- `header_prefix`
      }
      if (!missing(`sml_id`)) {
        stopifnot(is.numeric(`sml_id`), length(`sml_id`) == 1)
        self$`sml_id` <- `sml_id`
      }
      if (!missing(`smf_id_refs`)) {
        stopifnot(is.list(`smf_id_refs`), length(`smf_id_refs`) != 0)
        lapply(`smf_id_refs`, function(x) stopifnot(is.character(x)))
        self$`smf_id_refs` <- `smf_id_refs`
      }
      if (!missing(`database_identifier`)) {
        stopifnot(is.list(`database_identifier`), length(`database_identifier`) != 0)
        lapply(`database_identifier`, function(x) stopifnot(is.character(x)))
        self$`database_identifier` <- `database_identifier`
      }
      if (!missing(`chemical_formula`)) {
        stopifnot(is.list(`chemical_formula`), length(`chemical_formula`) != 0)
        lapply(`chemical_formula`, function(x) stopifnot(is.character(x)))
        self$`chemical_formula` <- `chemical_formula`
      }
      if (!missing(`smiles`)) {
        stopifnot(is.list(`smiles`), length(`smiles`) != 0)
        lapply(`smiles`, function(x) stopifnot(is.character(x)))
        self$`smiles` <- `smiles`
      }
      if (!missing(`inchi`)) {
        stopifnot(is.list(`inchi`), length(`inchi`) != 0)
        lapply(`inchi`, function(x) stopifnot(is.character(x)))
        self$`inchi` <- `inchi`
      }
      if (!missing(`chemical_name`)) {
        stopifnot(is.list(`chemical_name`), length(`chemical_name`) != 0)
        lapply(`chemical_name`, function(x) stopifnot(is.character(x)))
        self$`chemical_name` <- `chemical_name`
      }
      if (!missing(`uri`)) {
        stopifnot(is.list(`uri`), length(`uri`) != 0)
        lapply(`uri`, function(x) stopifnot(is.character(x)))
        self$`uri` <- `uri`
      }
      if (!missing(`theoretical_neutral_mass`)) {
        stopifnot(is.list(`theoretical_neutral_mass`), length(`theoretical_neutral_mass`) != 0)
        lapply(`theoretical_neutral_mass`, function(x) stopifnot(is.character(x)))
        self$`theoretical_neutral_mass` <- `theoretical_neutral_mass`
      }
      if (!missing(`adduct_ions`)) {
        stopifnot(is.list(`adduct_ions`), length(`adduct_ions`) != 0)
        lapply(`adduct_ions`, function(x) stopifnot(is.character(x)))
        self$`adduct_ions` <- `adduct_ions`
      }
      if (!missing(`reliability`)) {
        stopifnot(is.character(`reliability`), length(`reliability`) == 1)
        self$`reliability` <- `reliability`
      }
      if (!missing(`best_id_confidence_measure`)) {
        stopifnot(R6::is.R6(`best_id_confidence_measure`))
        self$`best_id_confidence_measure` <- `best_id_confidence_measure`
      }
      if (!missing(`best_id_confidence_value`)) {
        stopifnot(is.numeric(`best_id_confidence_value`), length(`best_id_confidence_value`) == 1)
        self$`best_id_confidence_value` <- `best_id_confidence_value`
      }
      if (!missing(`abundance_assay`)) {
        stopifnot(is.list(`abundance_assay`), length(`abundance_assay`) != 0)
        lapply(`abundance_assay`, function(x) stopifnot(is.character(x)))
        self$`abundance_assay` <- `abundance_assay`
      }
      if (!missing(`abundance_study_variable`)) {
        stopifnot(is.list(`abundance_study_variable`), length(`abundance_study_variable`) != 0)
        lapply(`abundance_study_variable`, function(x) stopifnot(is.character(x)))
        self$`abundance_study_variable` <- `abundance_study_variable`
      }
      if (!missing(`abundance_variation_study_variable`)) {
        stopifnot(is.list(`abundance_variation_study_variable`), length(`abundance_variation_study_variable`) != 0)
        lapply(`abundance_variation_study_variable`, function(x) stopifnot(is.character(x)))
        self$`abundance_variation_study_variable` <- `abundance_variation_study_variable`
      }
      if (!missing(`opt`)) {
        stopifnot(is.list(`opt`), length(`opt`) != 0)
        lapply(`opt`, function(x) stopifnot(R6::is.R6(x)))
        self$`opt` <- `opt`
      }
      if (!missing(`comment`)) {
        stopifnot(is.list(`comment`), length(`comment`) != 0)
        lapply(`comment`, function(x) stopifnot(R6::is.R6(x)))
        self$`comment` <- `comment`
      }
    },
    toJSON = function() {
      SmallMoleculeSummaryObject <- list()
      if (!is.null(self$`prefix`)) {
        SmallMoleculeSummaryObject[['prefix']] <- self$`prefix`
      }
      if (!is.null(self$`header_prefix`)) {
        SmallMoleculeSummaryObject[['header_prefix']] <- self$`header_prefix`
      }
      if (!is.null(self$`sml_id`)) {
        SmallMoleculeSummaryObject[['sml_id']] <- self$`sml_id`
      }
      if (!is.null(self$`smf_id_refs`)) {
        SmallMoleculeSummaryObject[['smf_id_refs']] <- self$`smf_id_refs`
      }
      if (!is.null(self$`database_identifier`)) {
        SmallMoleculeSummaryObject[['database_identifier']] <- self$`database_identifier`
      }
      if (!is.null(self$`chemical_formula`)) {
        SmallMoleculeSummaryObject[['chemical_formula']] <- self$`chemical_formula`
      }
      if (!is.null(self$`smiles`)) {
        SmallMoleculeSummaryObject[['smiles']] <- self$`smiles`
      }
      if (!is.null(self$`inchi`)) {
        SmallMoleculeSummaryObject[['inchi']] <- self$`inchi`
      }
      if (!is.null(self$`chemical_name`)) {
        SmallMoleculeSummaryObject[['chemical_name']] <- self$`chemical_name`
      }
      if (!is.null(self$`uri`)) {
        SmallMoleculeSummaryObject[['uri']] <- self$`uri`
      }
      if (!is.null(self$`theoretical_neutral_mass`)) {
        SmallMoleculeSummaryObject[['theoretical_neutral_mass']] <- self$`theoretical_neutral_mass`
      }
      if (!is.null(self$`adduct_ions`)) {
        SmallMoleculeSummaryObject[['adduct_ions']] <- self$`adduct_ions`
      }
      if (!is.null(self$`reliability`)) {
        SmallMoleculeSummaryObject[['reliability']] <- self$`reliability`
      }
      if (!is.null(self$`best_id_confidence_measure`)) {
        SmallMoleculeSummaryObject[['best_id_confidence_measure']] <- self$`best_id_confidence_measure`$toJSON()
      }
      if (!is.null(self$`best_id_confidence_value`)) {
        SmallMoleculeSummaryObject[['best_id_confidence_value']] <- self$`best_id_confidence_value`
      }
      if (!is.null(self$`abundance_assay`)) {
        SmallMoleculeSummaryObject[['abundance_assay']] <- self$`abundance_assay`
      }
      if (!is.null(self$`abundance_study_variable`)) {
        SmallMoleculeSummaryObject[['abundance_study_variable']] <- self$`abundance_study_variable`
      }
      if (!is.null(self$`abundance_variation_study_variable`)) {
        SmallMoleculeSummaryObject[['abundance_variation_study_variable']] <- self$`abundance_variation_study_variable`
      }
      if (!is.null(self$`opt`)) {
        SmallMoleculeSummaryObject[['opt']] <- lapply(self$`opt`, function(x) x$toJSON())
      }
      if (!is.null(self$`comment`)) {
        SmallMoleculeSummaryObject[['comment']] <- lapply(self$`comment`, function(x) x$toJSON())
      }

      SmallMoleculeSummaryObject
    },
    fromJSON = function(SmallMoleculeSummaryJson) {
      SmallMoleculeSummaryObject <- jsonlite::fromJSON(SmallMoleculeSummaryJson, simplifyVector = FALSE)
      if (!is.null(SmallMoleculeSummaryObject$`prefix`)) {
        self$`prefix` <- SmallMoleculeSummaryObject$`prefix`
      }
      if (!is.null(SmallMoleculeSummaryObject$`header_prefix`)) {
        self$`header_prefix` <- SmallMoleculeSummaryObject$`header_prefix`
      }
      if (!is.null(SmallMoleculeSummaryObject$`sml_id`)) {
        self$`sml_id` <- SmallMoleculeSummaryObject$`sml_id`
      }
      if (!is.null(SmallMoleculeSummaryObject$`smf_id_refs`)) {
        self$`smf_id_refs` <- SmallMoleculeSummaryObject$`smf_id_refs`
      }
      if (!is.null(SmallMoleculeSummaryObject$`database_identifier`)) {
        self$`database_identifier` <- SmallMoleculeSummaryObject$`database_identifier`
      }
      if (!is.null(SmallMoleculeSummaryObject$`chemical_formula`)) {
        self$`chemical_formula` <- SmallMoleculeSummaryObject$`chemical_formula`
      }
      if (!is.null(SmallMoleculeSummaryObject$`smiles`)) {
        self$`smiles` <- SmallMoleculeSummaryObject$`smiles`
      }
      if (!is.null(SmallMoleculeSummaryObject$`inchi`)) {
        self$`inchi` <- SmallMoleculeSummaryObject$`inchi`
      }
      if (!is.null(SmallMoleculeSummaryObject$`chemical_name`)) {
        self$`chemical_name` <- SmallMoleculeSummaryObject$`chemical_name`
      }
      if (!is.null(SmallMoleculeSummaryObject$`uri`)) {
        self$`uri` <- SmallMoleculeSummaryObject$`uri`
      }
      if (!is.null(SmallMoleculeSummaryObject$`theoretical_neutral_mass`)) {
        self$`theoretical_neutral_mass` <- SmallMoleculeSummaryObject$`theoretical_neutral_mass`
      }
      if (!is.null(SmallMoleculeSummaryObject$`adduct_ions`)) {
        self$`adduct_ions` <- SmallMoleculeSummaryObject$`adduct_ions`
      }
      if (!is.null(SmallMoleculeSummaryObject$`reliability`)) {
        self$`reliability` <- SmallMoleculeSummaryObject$`reliability`
      }
      if (!is.null(SmallMoleculeSummaryObject$`best_id_confidence_measure`)) {
        `best_id_confidence_measureObject` <- Parameter$new()
        `best_id_confidence_measureObject`$fromJSON(jsonlite::toJSON(SmallMoleculeSummaryObject$best_id_confidence_measure, auto_unbox = TRUE))
        self$`best_id_confidence_measure` <- `best_id_confidence_measureObject`
      }
      if (!is.null(SmallMoleculeSummaryObject$`best_id_confidence_value`)) {
        self$`best_id_confidence_value` <- SmallMoleculeSummaryObject$`best_id_confidence_value`
      }
      if (!is.null(SmallMoleculeSummaryObject$`abundance_assay`)) {
        self$`abundance_assay` <- SmallMoleculeSummaryObject$`abundance_assay`
      }
      if (!is.null(SmallMoleculeSummaryObject$`abundance_study_variable`)) {
        self$`abundance_study_variable` <- SmallMoleculeSummaryObject$`abundance_study_variable`
      }
      if (!is.null(SmallMoleculeSummaryObject$`abundance_variation_study_variable`)) {
        self$`abundance_variation_study_variable` <- SmallMoleculeSummaryObject$`abundance_variation_study_variable`
      }
      if (!is.null(SmallMoleculeSummaryObject$`opt`)) {
        self$`opt` <- lapply(SmallMoleculeSummaryObject$`opt`, function(x) {
          `optObject` <- OptColumnMapping$new()
          `optObject`$fromJSON(jsonlite::toJSON(x, auto_unbox = TRUE))
          `optObject`
        })
      }
      if (!is.null(SmallMoleculeSummaryObject$`comment`)) {
        self$`comment` <- lapply(SmallMoleculeSummaryObject$`comment`, function(x) {
          `commentObject` <- Comment$new()
          `commentObject`$fromJSON(jsonlite::toJSON(x, auto_unbox = TRUE))
          `commentObject`
        })
      }
    },
    toJSONString = function() {
       sprintf(
        '{
           "prefix": %s,
           "header_prefix": %s,
           "sml_id": %s,
           "smf_id_refs": [%s],
           "database_identifier": [%s],
           "chemical_formula": [%s],
           "smiles": [%s],
           "inchi": [%s],
           "chemical_name": [%s],
           "uri": [%s],
           "theoretical_neutral_mass": [%s],
           "adduct_ions": [%s],
           "reliability": %s,
           "best_id_confidence_measure": %s,
           "best_id_confidence_value": %d,
           "abundance_assay": [%s],
           "abundance_study_variable": [%s],
           "abundance_variation_study_variable": [%s],
           "opt": [%s],
           "comment": [%s]
        }',
        self$`prefix`,
        self$`header_prefix`,
        self$`sml_id`,
        lapply(self$`smf_id_refs`, function(x) paste(paste0('"', x, '"'), sep=",")),
        lapply(self$`database_identifier`, function(x) paste(paste0('"', x, '"'), sep=",")),
        lapply(self$`chemical_formula`, function(x) paste(paste0('"', x, '"'), sep=",")),
        lapply(self$`smiles`, function(x) paste(paste0('"', x, '"'), sep=",")),
        lapply(self$`inchi`, function(x) paste(paste0('"', x, '"'), sep=",")),
        lapply(self$`chemical_name`, function(x) paste(paste0('"', x, '"'), sep=",")),
        lapply(self$`uri`, function(x) paste(paste0('"', x, '"'), sep=",")),
        lapply(self$`theoretical_neutral_mass`, function(x) paste(paste0('"', x, '"'), sep=",")),
        lapply(self$`adduct_ions`, function(x) paste(paste0('"', x, '"'), sep=",")),
        self$`reliability`,
        self$`best_id_confidence_measure`$toJSON(),
        self$`best_id_confidence_value`,
        lapply(self$`abundance_assay`, function(x) paste(paste0('"', x, '"'), sep=",")),
        lapply(self$`abundance_study_variable`, function(x) paste(paste0('"', x, '"'), sep=",")),
        lapply(self$`abundance_variation_study_variable`, function(x) paste(paste0('"', x, '"'), sep=",")),
        lapply(self$`opt`, function(x) paste(x$toJSON(), sep=",")),
        lapply(self$`comment`, function(x) paste(x$toJSON(), sep=","))
      )
    },
    fromJSONString = function(SmallMoleculeSummaryJson) {
      SmallMoleculeSummaryObject <- jsonlite::fromJSON(SmallMoleculeSummaryJson, simplifyVector = FALSE)
      self$`prefix` <- SmallMoleculeSummaryObject$`prefix`
      self$`header_prefix` <- SmallMoleculeSummaryObject$`header_prefix`
      self$`sml_id` <- SmallMoleculeSummaryObject$`sml_id`
      self$`smf_id_refs` <- SmallMoleculeSummaryObject$`smf_id_refs`
      self$`database_identifier` <- SmallMoleculeSummaryObject$`database_identifier`
      self$`chemical_formula` <- SmallMoleculeSummaryObject$`chemical_formula`
      self$`smiles` <- SmallMoleculeSummaryObject$`smiles`
      self$`inchi` <- SmallMoleculeSummaryObject$`inchi`
      self$`chemical_name` <- SmallMoleculeSummaryObject$`chemical_name`
      self$`uri` <- SmallMoleculeSummaryObject$`uri`
      self$`theoretical_neutral_mass` <- SmallMoleculeSummaryObject$`theoretical_neutral_mass`
      self$`adduct_ions` <- SmallMoleculeSummaryObject$`adduct_ions`
      self$`reliability` <- SmallMoleculeSummaryObject$`reliability`
      ParameterObject <- Parameter$new()
      self$`best_id_confidence_measure` <- ParameterObject$fromJSON(jsonlite::toJSON(SmallMoleculeSummaryObject$best_id_confidence_measure, auto_unbox = TRUE))
      self$`best_id_confidence_value` <- SmallMoleculeSummaryObject$`best_id_confidence_value`
      self$`abundance_assay` <- SmallMoleculeSummaryObject$`abundance_assay`
      self$`abundance_study_variable` <- SmallMoleculeSummaryObject$`abundance_study_variable`
      self$`abundance_variation_study_variable` <- SmallMoleculeSummaryObject$`abundance_variation_study_variable`
      self$`opt` <- lapply(SmallMoleculeSummaryObject$`opt`, function(x) OptColumnMapping$new()$fromJSON(jsonlite::toJSON(x, auto_unbox = TRUE)))
      self$`comment` <- lapply(SmallMoleculeSummaryObject$`comment`, function(x) Comment$new()$fromJSON(jsonlite::toJSON(x, auto_unbox = TRUE)))
    }
  )
)
