# mzTab-M reference implementation and validation API.
# 
# This is the mzTab-M reference implementation and validation API service.
# 
# OpenAPI spec version: 2.0.0
# Contact: nils.hoffmann@isas.de
# Generated by: https://github.com/swagger-api/swagger-codegen.git


#' SpectraRef Class
#'
#' Reference to a spectrum in a spectrum file, for example a fragmentation spectrum has been used to support the identification. If a separate spectrum file has been used for fragmentation spectrum, this MUST be reported in the metadata section as additional ms_runs. The reference must be in the format ms_run[1-n]:{SPECTRA_REF} where SPECTRA_REF MUST follow the format defined in 5.2 (including references to chromatograms where these are used to inform identification). Multiple spectra MUST be referenced using a “|” delimited list for the (rare) cases in which search engines have combined or aggregated multiple spectra in advance of the search to make identifications.  If a fragmentation spectrum has not been used, the value should indicate the ms_run to which is identification is mapped e.g. “ms_run[1]”. 
#'
#' @field ms_run 
#' @field reference 
#'
#' mzTab-M specification example(s)
#' \preformatted{
#' SEH	SME_ID	…	spectra_ref	…
SME	1			ms_run[1]:index=5	…

#' }
#' 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
SpectraRef <- R6::R6Class(
  'SpectraRef',
  public = list(
    `ms_run` = NULL,
    `reference` = NULL,
    initialize = function(`ms_run`, `reference`){
      if (!missing(`ms_run`)) {
        stopifnot(R6::is.R6(`ms_run`))
        self$`ms_run` <- `ms_run`
      }
      if (!missing(`reference`)) {
        stopifnot(is.character(`reference`), length(`reference`) == 1)
        self$`reference` <- `reference`
      }
    },
    toJSON = function() {
      SpectraRefObject <- list()
      if (!is.null(self$`ms_run`)) {
        SpectraRefObject[['ms_run']] <- self$`ms_run`$toJSON()
      }
      if (!is.null(self$`reference`)) {
        SpectraRefObject[['reference']] <- self$`reference`
      }

      SpectraRefObject
    },
    fromJSON = function(SpectraRefJson) {
      SpectraRefObject <- jsonlite::fromJSON(SpectraRefJson, simplifyVector = FALSE)
      if (!is.null(SpectraRefObject$`ms_run`)) {
        `ms_runObject` <- MsRun$new()
        `ms_runObject`$fromJSON(jsonlite::toJSON(SpectraRefObject$ms_run, auto_unbox = TRUE))
        self$`ms_run` <- `ms_runObject`
      }
      if (!is.null(SpectraRefObject$`reference`)) {
        self$`reference` <- SpectraRefObject$`reference`
      }
    },
    toJSONString = function() {
       sprintf(
        '{
           "ms_run": %s,
           "reference": %s
        }',
        self$`ms_run`$toJSON(),
        self$`reference`
      )
    },
    fromJSONString = function(SpectraRefJson) {
      SpectraRefObject <- jsonlite::fromJSON(SpectraRefJson, simplifyVector = FALSE)
      MsRunObject <- MsRun$new()
      self$`ms_run` <- MsRunObject$fromJSON(jsonlite::toJSON(SpectraRefObject$ms_run, auto_unbox = TRUE))
      self$`reference` <- SpectraRefObject$`reference`
    }
  )
)
